"""
   Python SDK for OpenFGA

   API version: 1.x
   Website: https://openfga.dev
   Documentation: https://openfga.dev/docs
   Support: https://openfga.dev/community
   License: [Apache-2.0](https://github.com/openfga/python-sdk/blob/main/LICENSE)

   NOTE: This file was auto generated by OpenAPI Generator (https://openapi-generator.tech). DO NOT EDIT.
"""

from openfga_sdk.models.relationship_condition import RelationshipCondition
from openfga_sdk.models.tuple_key import TupleKey


class ClientTuple:
    """
    ClientTuple encapsulates the client tuple
    """

    def __init__(
        self,
        user: str,
        relation: str,
        object: str,
        condition: RelationshipCondition | None = None,
    ):
        self._user = user
        self._relation = relation
        self._object = object
        self._condition = condition

    def __eq__(self, other):
        return (
            self.user == other.user
            and self.relation == other.relation
            and self.object == other.object
        )

    @property
    def user(self):
        """
        Return user
        """
        return self._user

    @property
    def relation(self):
        """
        Return relation
        """
        return self._relation

    @property
    def object(self):
        """
        Return object
        """
        return self._object

    @property
    def condition(self):
        """
        Return condition
        """
        return self._condition

    @user.setter
    def user(self, value):
        """
        Set user
        """
        self._user = value

    @relation.setter
    def relation(self, value):
        """
        Set relation
        """
        self._relation = value

    @object.setter
    def object(self, value):
        """
        Set object
        """
        self._object = value

    @condition.setter
    def condition(self, value):
        """
        Set condition
        """
        self._condition = value

    @property
    def tuple_key(self):
        """
        Return the tuple as tuple_key
        """
        return TupleKey(
            object=self.object,
            relation=self.relation,
            user=self.user,
            condition=self.condition,
        )


def convert_tuple_keys(lists: list[ClientTuple]):
    """
    Return the items as tuple_keys
    """
    if lists is None:
        return None
    items = map(lambda item: item.tuple_key, lists)
    return list(items)
